package generics;

public class Box<T> {
    T item;


    // declare generics T (a new type variable, called type parameter)
    // This can be *any* reference type such as String
    public Box(T item) {
        this.item = item;
    }

    // ^^ this function can be used by any type, for example
    // okay now we declared the item in the box, it can be, basically, everyting
    // now lets look at application
    public Box() {
    }

    public void add(T thing) {
        item = thing;
    }

    public void empty() {
        item = null;
    }
}
