package generics;

import inheritance.Rectangle;
import inheritance.Shape;
import inheritance.Square;

public class BoxUser {
    public static void main(String[] args) {
        /*
         * Let's apply our generic box to store some Rectangles and Shapes and explore their relationships
         */

        // if the generic is on the left-hand side <> let the compiler infer the type
        Box<Integer> intBox = new Box<>(); // = new Box<Integer>();
        Box<Rectangle> rectBox = new Box<>();
        Box<Square> sqBox = new Box<>();
        Box<Blah> blahBox = new Box<>();

        emptyRegularBox(intBox);

    }

    private class Blah {

    }


    public static void emptyRegularBox(Box<?> box) {  // ? symbol in java is like a wildcard, which is similar to generics type
        box.empty();
    }

    public static void emptyRectangleBox(Box<Rectangle> box) {
        box.empty();
    }

    public static void emptyShapeBox(Box<Shape> box) {
        box.empty();
    }
}
