package inheritance;

public class Rectangle implements Shape {
    // private fields mean that subclasses can't access them directly
    private double length;
    private double width;

    public Rectangle(double length, double width) {
        this.length = length;
        this.width = width;
    }

    public double area() {
        return length * width;
    }

    public int numSides() {
        return 4;
    }
}
