import java.util.*;

// simple enum

// we can treat enum as a special data type
public enum Level {
    GOOD,
    OKAY,
    BAD
}

public enum Week {
	MONDAY,
	TUESDAY...
}

public enum Year {
	JAN,
	FEB,
}

// refer to the constant in the enum we declared above
//Level level = Level.GOOD;

// type/name of enum  || name of the variable = Name of the enum.


// if statement
Level level = Level.OKAY;

if (level == GOOD) {
	// do something
} else if (level == BAD) {
	// do something
} else {

}


// switch
switch(level) {
	case GOOD: ...; break;
	case BAD: ...; break;
	case OKAY: ...; break;
}


// enum iteration && enum to string
for (Level lev : Level.values()) {
	System.out.println(lev);
}



// GOOD
// BAD
// OKAY

String levelToString = Level.Good.toSTring();




