package inheritance;

public abstract class ColoredShape implements Shape {
    /* This field is private so subclasses will need 
     * to use getters and setters to access and change it
     */
    private int color;

    public int getColor() {
        return color;
    }

    public void setColor(int color) {
        this.color = color;
    }

    // New area method that will use the color field
    abstract double area2(); 
    
    // new numSides method that will use the color field
    abstract int numSides2(); 
}
