package inheritance;

public class Square extends Rectangle implements Shape {
    /* We need to make a new variable for length here
     * since length and width from the Rectangle class
     * are private.
     */
    private double length;

    public Square(double length) {
        super(length, length);
        this.length = length;
    }

    /* @Override helps prevent you from overloading by
     * accident. It will tell the compiler to check the
     * parent class for a method with the same signature
     */
    @Override
    public double area() {
        return length * length;
    }
}
